searchNodes=[{"doc":"","ref":"Fsmx.html","title":"Fsmx","type":"module"},{"doc":"","ref":"Fsmx.html#transition/3","title":"Fsmx.transition/3","type":"function"},{"doc":"","ref":"Fsmx.html#transition_changeset/4","title":"Fsmx.transition_changeset/4","type":"function"},{"doc":"","ref":"Fsmx.html#transition_multi/6","title":"Fsmx.transition_multi/6","type":"function"},{"doc":"","ref":"Fsmx.html#t:opts_t/0","title":"Fsmx.opts_t/0","type":"type"},{"doc":"","ref":"Fsmx.html#t:state_t/0","title":"Fsmx.state_t/0","type":"type"},{"doc":"Holds transition and callback logic for finite state machinesBy default, when using use Fsmx.Struct, this is automatically included as well. Specifying use Fsmx.Struct, fsm: MyApp.Fsm allows you to decouple this, thoughdefmodule MyApp.Struct do defstruct [:state] end defmodule MyApp.Fsm do use Fsmx.Fsm, transitions: %{} def before_transition(struct, _from, _to, _state_field) do # ... end endCallbacksCallbacks are defined as functions in the module that includes Fsmx.Fsm (which could be the one that includes Fsmx.Struct). They are called with the struct, the current state, the new state, and the state field name. This allows for different callbacks per state field.The following callbacks are deprecated and will be removed in a future:before_transition/3transition_changeset/4after_transition_multi/3","ref":"Fsmx.Fsm.html","title":"Fsmx.Fsm","type":"behaviour"},{"doc":"","ref":"Fsmx.Fsm.html#c:after_transition_multi/4","title":"Fsmx.Fsm.after_transition_multi/4","type":"callback"},{"doc":"","ref":"Fsmx.Fsm.html#c:before_transition/4","title":"Fsmx.Fsm.before_transition/4","type":"callback"},{"doc":"","ref":"Fsmx.Fsm.html#default_state_field/0","title":"Fsmx.Fsm.default_state_field/0","type":"function"},{"doc":"","ref":"Fsmx.Fsm.html#c:transition_changeset/5","title":"Fsmx.Fsm.transition_changeset/5","type":"callback"},{"doc":"Main module to include finite-state machine logic into your struct/schemaIf no state_field is defined, it assumes the name is :state.Basic usage:defmodule MyApp.Struct do defstruct [:state] use Fsmx.Struct, transitions: %{} endYou can also specify a custom state field:defmodule MyApp.Struct do defstruct [:my_state] use Fsmx.Struct, state_field: :my_state, transitions: %{} endOr even multiple state fields, that will behave independently and have their own transition definition, etc. In this case :state is still used as the default:defmodule MyApp.Struct do defstruct [:state, :other_state] use Fsmx.Struct, transitions: %{} use Fsmx.Struct, state_field: :other_state, transitions: %{} end","ref":"Fsmx.Struct.html","title":"Fsmx.Struct","type":"module"},{"doc":"FsmxA Finite-state machine implementation in Elixir, with opt-in Ecto friendliness.Highlights:Plays nicely with both bare Elixir structs and Ecto changesetsAbility to wrap transitions inside an Ecto.Multi for atomic updatesGuides you in the right direction when it comes to side effectsInstallationUsageSimple state machineCallbacks before transitionsValidating transitionsDecoupling logic from dataEcto supportTransition changesetsTransition with Ecto.MultiA note on side effectsContributing","ref":"readme.html","title":"Fsmx","type":"extras"},{"doc":"Add fsmx to your list of dependencies in mix.exs:def deps do [ {:fsmx, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"Fsmx - Installation","type":"extras"},{"doc":"Simple state machinedefmodule App.StateMachine do defstruct [:state, :data] use Fsmx.Struct, transitions: %{ &quot;one&quot; =&gt; [&quot;two&quot;, &quot;three&quot;], &quot;two&quot; =&gt; [&quot;three&quot;, &quot;four&quot;], &quot;three&quot; =&gt; &quot;four&quot;, &quot;four&quot; =&gt; :*, # can transition to any state :* =&gt; [&quot;five&quot;] # can transition from any state to &quot;five&quot; } endUse it via the Fsmx.transition/2 function:struct = %App.StateMachine{state: &quot;one&quot;, data: nil} Fsmx.transition(struct, &quot;two&quot;) # {:ok, %App.StateMachine{state: &quot;two&quot;}} Fsmx.transition(struct, &quot;four&quot;) # {:error, &quot;invalid transition from one to four&quot;}Callbacks before transitionsYou can implement a before_transition/3 callback to mutate the struct when before a transition happens. You only need to pattern-match on the scenarios you want to catch. No need to add a catch-all/do-nothing function at the end (the library already does that for you).defmodule App.StateMachine do # ... def before_transition(struct, &quot;two&quot;, _destination_state) do {:ok, %{struct | data: %{foo: :bar}}} end endUsage:struct = %App.StateMachine{state: &quot;two&quot;, data: nil} Fsmx.transition(struct, &quot;three&quot;) # {:ok, %App.StateMachine{state: &quot;three&quot;, data: %{foo: :bar}}Validating transitionsThe same before_transition/3 callback can be used to add custom validation logic, by returning an {:error, _} tuple when needed:defmodule App.StateMachine do # ... def before_transition(%{data: nil}, _initial_state, &quot;four&quot;) do {:error, &quot;cannot reach state four without data&quot;} end endUsage:struct = %App.StateMachine{state: &quot;two&quot;, data: nil} Fsmx.transition(struct, &quot;four&quot;) # {:error, &quot;cannot reach state four without data&quot;}Decoupling logic from dataSince logic can grow a lot, and fall out of scope in your structs/schemas, it's often useful to separate all that business logic into a separate module:defmodule App.StateMachine do defstruct [:state] use Fsmx.Struct, fsm: App.BusinessLogic end defmodule App.BusinessLogic do use Fsmx.Fsm, transitions: %{ &quot;one&quot; =&gt; [&quot;two&quot;, &quot;three&quot;], &quot;two&quot; =&gt; [&quot;three&quot;, &quot;four&quot;], &quot;three&quot; =&gt; &quot;four&quot; } # callbacks go here now def before_transition(struct, &quot;two&quot;, _destination_state) do {:ok, %{struct | data: %{foo: :bar}}} end def before_transition(%{data: nil}, _initial_state, &quot;four&quot;) do {:error, &quot;cannot reach state four without data&quot;} end endMultiple state machines in the same structNot all structs have a single state machine, sometimes you might need more, using different fields for that effect. Here's how you can do it:defmodule App.StateMachine do defstruct [:state, :other_state, :data] use Fsmx.Struct, transitions: %{ &quot;one&quot; =&gt; [&quot;two&quot;, &quot;three&quot;], &quot;two&quot; =&gt; [&quot;three&quot;, &quot;four&quot;], &quot;three&quot; =&gt; &quot;four&quot;, &quot;four&quot; =&gt; :*, # can transition to any state :* =&gt; [&quot;five&quot;] # can transition from any state to &quot;five&quot; } use Fsmx.Struct, state_field: :other_state, transitions: %{ &quot;initial&quot; =&gt; [&quot;middle&quot;, &quot;middle2&quot;], &quot;middle&quot; =&gt; &quot;middle2&quot;, :* =&gt; &quot;final&quot; } endUse it via the Fsmx.transition/3 function:struct = %App.StateMachine{state: &quot;one&quot;, other_state: &quot;initial&quot;, data: nil} Fsmx.transition(struct, &quot;two&quot;) # {:ok, %App.StateMachine{state: &quot;two&quot;, other_state: &quot;initial&quot;}} Fsmx.transition(struct, &quot;final&quot;, field: :other_state) # {:ok, %App.StateMachine{state: &quot;one&quot;, other_state: &quot;final&quot;}}","ref":"readme.html#usage","title":"Fsmx - Usage","type":"extras"},{"doc":"Support for Ecto is built in, as long as ecto is in your mix.exs dependencies. With it, you get the ability to define state machines using Ecto schemas, and the Fsmx.Ecto module:defmodule App.StateMachineSchema do use Ecto.Schema schema &quot;state_machine&quot; do field :state, :string, default: &quot;one&quot; field :data, :map end use Fsmx.Struct, transitions: %{ &quot;one&quot; =&gt; [&quot;two&quot;, &quot;three&quot;], &quot;two&quot; =&gt; [&quot;three&quot;, &quot;four&quot;], &quot;three&quot; =&gt; &quot;four&quot; } endYou can then mutate your state machine in one of two ways:1. Transition changesetsReturns a changeset that mutates the :state field (or {:error, _} if the transition is invalid).{:ok, schema} = %App.StateMachineSchema{state: &quot;one&quot;} |&gt; Repo.insert() Fsmx.transition_changeset(schema, &quot;two&quot;) # #Ecto.Changeset&lt;changes: %{state: &quot;two&quot;}&gt;You can customize the changeset function, and again pattern match on specific transitions, and additional params:defmodule App.StateMachineSchema do # ... # only include sent data on transitions from &quot;one&quot; to &quot;two&quot; def transition_changeset(changeset, &quot;one&quot;, &quot;two&quot;, params) do # changeset already includes a :state field change changeset |&gt; cast(params, [:data]) |&gt; validate_required([:data]) endUsage:{:ok, schema} = %App.StateMachineSchema{state: &quot;one&quot;} |&gt; Repo.insert() Fsmx.transition_changeset(schema, &quot;two&quot;, %{&quot;data&quot;=&gt; %{foo: :bar}}) # #Ecto.Changeset&lt;changes: %{state: &quot;two&quot;, data: %{foo: :bar}&gt;2. Transition with Ecto.MultiNote: Please read a note on side effects first. Your future self will thank you.If a state transition is part of a larger operation, and you want to guarantee atomicity of the whole operation, you can plug a state transition into an Ecto.Multi. The same changeset seen above will be used here:{:ok, schema} = %App.StateMachineSchema{state: &quot;one&quot;} |&gt; Repo.insert() Ecto.Multi.new() |&gt; Fsmx.transition_multi(schema, &quot;transition-id&quot;, &quot;two&quot;, %{&quot;data&quot; =&gt; %{foo: :bar}}) |&gt; Repo.transaction()When using Ecto.Multi, you also get an additional after_transition_multi/3 callback, where you can append additional operations the resulting transaction, such as dealing with side effects (but again, please know that side effects are tricky)defmodule App.StateMachineSchema do def after_transition_multi(schema, _from, &quot;four&quot;) do Mailer.notify_admin(schema) |&gt; Bamboo.deliver_later() {:ok, nil} end endNote that after_transition_multi/3 callbacks still run inside the database transaction, so be careful with expensive operations. In this example Bamboo.deliver_later/1 (from the awesome Bamboo package) doesn't spend time sending the actual email, it just spawns a task to do it asynchronously.","ref":"readme.html#ecto-support","title":"Fsmx - Ecto support","type":"extras"},{"doc":"Side effects are tricky. Database transactions are meant to guarantee atomicity, but side effects often touch beyond the database. Sending emails when a task is complete is a straight-forward example.When you run side effects within an Ecto.Multi you need to be aware that, should the transaction later be rolled back, there's no way to un-send that email.If the side effect is the last operation within your Ecto.Multi, you're probably 99% fine, which works for a lot of cases. But if you have more complex transactions, or if you do need 99.9999% consistency guarantees (because, let's face it, 100% is a pipe dream), then this simple library might not be for you.Consider looking at Sage, for instance.# this is *probably* fine Ecto.Multi.new() |&gt; Fsmx.transition_multi(schema, &quot;transition-id&quot;, &quot;two&quot;, %{&quot;data&quot; =&gt; %{foo: :bar}}) |&gt; Repo.transaction() # this is dangerous, because your transition callback # will run before the whole database transaction has run Ecto.Multi.new() |&gt; Fsmx.transition_multi(schema, &quot;transition-id&quot;, &quot;two&quot;, %{&quot;data&quot; =&gt; %{foo: :bar}}) |&gt; Ecto.Multi.update(:update, a_very_unreliable_changeset()) |&gt; Repo.transaction()","ref":"readme.html#a-note-on-side-effects","title":"Fsmx - A note on side effects","type":"extras"},{"doc":"Feel free to contribute. Either by opening an issue, a Pull Request, or contacting the team directlyIf you found a bug, please open an issue. You can also open a PR for bugs or new features. PRs will be reviewed and subject to our style guide and linters.AboutFsmx is maintained by Subvisual.&lt;img alt=&quot;Subvisual logo&quot; src=&quot;https://raw.githubusercontent.com/subvisual/guides/master/github/templates/subvisual_logo_with_name.png&quot; width=&quot;350px&quot; /&gt;","ref":"readme.html#contributing","title":"Fsmx - Contributing","type":"extras"}]